#ifndef PACKAGEMANAGEMENT_MINGWBUNDLE_H
#define PACKAGEMANAGEMENT_MINGWBUNDLE_H

#include "package.h"
#include "alpmdatabase.h"

#include <c++utilities/application/argumentparser.h>

#include <QList>

namespace PackageManagement {

class Manager;

class MingwBundle
{
public:
    MingwBundle(const Manager &manager, const ApplicationUtilities::StringVector &packages, const ApplicationUtilities::StringVector &iconPackages);

    void createBundle(const std::string &targetDir, const std::string &targetName, const std::string &targetFormat) const;

private:
    void addDependencies(const Package *pkg);

    const Manager &m_manager;
    std::list<std::pair<const AlpmDataBase *, const Package *> > m_packages;
};

} // namespace PackageManagement

#endif // PACKAGEMANAGEMENT_MINGWBUNDLE_H
