#ifndef REPOINDEX_SERVER_H
#define REPOINDEX_SERVER_H

#include <QObject>
#include <QList>
#include <QHostAddress>
#include <QWebSocketServer>

namespace PackageManagement {

class Config;
class Manager;

}

namespace Network {

class Connection;

class Server : public QObject
{
    Q_OBJECT

public:
    Server(const PackageManagement::Manager &alpmManager, const PackageManagement::Config &config, QObject *parent = nullptr);
    ~Server();

signals:
    void closed();
    void connectionEstablished(Connection *connection);

private slots:
    void incomingConnection();

private:
    QWebSocketServer *m_server;
    const PackageManagement::Manager &m_alpmManager;
};

}

#endif // SERVER_H
