projectname = repoindex
appname = "Repository Index"
appauthor = Martchus
appurl = "https://github.com/$${appauthor}/$${projectname}"
VERSION = 1.0.0

# include ../../common.pri when building as part of a subdirs project; otherwise include general.pri
!include(../../common.pri) {
    !include(./general.pri) {
        error("Couldn't find the common.pri or the general.pri file!")
    }
}

TEMPLATE = app

CONFIG += console # enables qDebug()

QT += core network websockets concurrent KArchive

SOURCES += main.cpp \
    alpm/manager.cpp \
    alpm/package.cpp \
    alpm/utilities.cpp \
    network/server.cpp \
    network/connection.cpp \
    alpm/group.cpp \
    alpm/config.cpp \
    alpm/resolvebuildorder.cpp \
    alpm/mingwbundle.cpp \
    network/userrepository.cpp \
    alpm/alpmpackage.cpp \
    alpm/aurpackage.cpp \
    alpm/alpmdatabase.cpp \
    alpm/repository.cpp \
    alpm/upgradelookup.cpp

HEADERS += \
    alpm/manager.h \
    alpm/package.h \
    alpm/list.h \
    alpm/utilities.h \
    network/server.h \
    network/connection.h \
    alpm/group.h \
    alpm/config.h \
    alpm/resolvebuildorder.h \
    alpm/mingwbundle.h \
    network/userrepository.h \
    alpm/alpmpackage.h \
    alpm/aurpackage.h \
    alpm/alpmdatabase.h \
    alpm/repository.h \
    alpm/upgradelookup.h

DISTFILES += \
    README.md \
    LICENSE \
    web/index.html \
    web/js/alpm.js \
    web/js/pagination.js \
    web/js/entrymanagement.js \
    web/js/packagemanagement.js \
    web/js/groupmanagement.js \
    web/js/pagemanagement.js \
    web/js/repomanagement.js \
    web/js/proto.js \
    web/js/utils.js \
    web/css/core.css \
    web/css/dashboard.css \
    repoindex.conf.js

# defines
CONFIG(release, debug|release) {
    DEFINES += NDEBUG
}

# libs and includepath
CONFIG(debug, debug|release) {
    LIBS += -lc++utilitiesd
} else {
    LIBS += -lc++utilities
}
LIBS += -lalpm -lKF5Archive

# installs
target.path = $$(INSTALL_ROOT)/bin
INSTALLS += target
